﻿----------------------------------------------------------------------------------------------------
-- DroodFocus 4.1.3 - spellsList
-- Author : Meranannon - Discordia - Vol'jin (EU)
-- rev 1
----------------------------------------------------------------------------------------------------
-- Liste de sorts prédéfinies
----------------------------------------------------------------------------------------------------
local DF = DF_namespace
DF.spellsList ={}
DF.spellsListCheck={}

DF.spellsListspecial ={
	
	-- specials debuff
	{["texte"]=93622,["valeur"]="93622",["alttexte"]="Berzerk mangle's proc",["ltype"]=1}, -- proc berzerk (refresh mutilation cd)
	{["texte"]=80951,["valeur"]="80951",["alttexte"]="Pulverize crit buff",["ltype"]=1}, -- proc pulverize (+crit from lacerate after pulverize)
	{["texte"]=33876,["valeur"]="33876;33878;46857;50271;35290;16511",["alttexte"]="Debuffs +30% bleed",["ltype"]=1}, -- Mangle debuff & co
	{["texte"]=91565,["valeur"]="91565;7386;8647;35387;50498",["alttexte"]="Debuffs -12% armor",["ltype"]=1}, -- armor debuffs
	{["texte"]=99,["valeur"]="99;1160;702;26017",["alttexte"]="Debuffs -10% damage",["ltype"]=1}, -- PA debuffs
	{["texte"]=90166,["valeur"]="90166",["alttexte"]="4pT11 feral bonus",["ltype"]=1},
	
	-- items (proc)
	{["texte"]=59520,["valeur"]="92108;59520",["ltype"]=2}, -- Unheeded Warning
	{["texte"]=50362,["valeur"]="71492;71484;71485;71560;71561;71556",["ltype"]=2}, -- Volonté de porte-mort	(normal et héroïque) - Druide: Hâte/force/agilité
	{["texte"]=47115,["valeur"]="67703;67708;67772;67773",["ltype"]=2}, -- Verdict de la mort (normal et héroïque)			
	{["texte"]=50355,["valeur"]="71396",["ltype"]=2}, -- Jeton de guerre de Herkuml	
	{["texte"]=50456,["valeur"]="71175;67354",["ltype"]=2}, -- Idole de la lune gémissante
	{["texte"]=47668,["valeur"]="67355",["ltype"]=2}, -- Idole de mutilation		
	{["texte"]=50457,["valeur"]="71177",["ltype"]=2}, -- Idole de l'éclipse de lune
	{["texte"]=50454,["valeur"]="71184",["ltype"]=2}, -- Idole du saule noir
	{["texte"]=50402,["valeur"]="72412",["ltype"]=2}, -- Bague de vengeance sans fin du Verdict des cendres	
	{["texte"]=44253,["valeur"]="60233",["ltype"]=2}, -- Carte de Sombrelune : Grandeur		
	{["texte"]=45931,["valeur"]="65019",["ltype"]=2}, -- Pierre runique de Mjolnir
	{["texte"]=50198,["valeur"]="71403",["ltype"]=2}, -- Scorpion incrusté d'aiguilles
	{["texte"]=40256,["valeur"]="60437",["ltype"]=2}, -- Le glas sinistre
}

-- construction de la liste des sorts a partir du grimoire et fusion des 2 listes
function DF:spellslist_initTable()

	if DF.spellsList then
		DF.spellsList=table.wipe(DF.spellsList)
	end

	if DF.spellsListCheck then
		DF.spellsListCheck=table.wipe(DF.spellsListCheck)
	end
	
	local num=1
	
	for i = 1, GetNumSpellTabs() do
		
	   local name, _, offset, numSpells = GetSpellTabInfo(i)
	   
	   if not name then
	      break;
	   end
   
	   for s = offset + 1, offset + numSpells do
	   	
	   	local	spell, rank = GetSpellBookItemName(s, BOOKTYPE_SPELL)
	   	_, spellId = GetSpellBookItemInfo(s, BOOKTYPE_SPELL)

			if not IsPassiveSpell(s, BOOKTYPE_SPELL) then

				if rank~="" then
					finalname="(E) "..spell.." ("..tostring(rank)..")"
				else
					finalname="(E) "..spell
				end

				if string.len(finalname)>32 then
					finalname=string.sub(finalname, 1 ,32).."..."
				end

				DF.spellsList[num]={}
				DF.spellsListCheck[num]={}

				latooltip="|cFFFFFF00Sort du grimoire|cFFFFFFFF\n"
				lenom=GetSpellInfo(spellId)
				if lenom==nil then
					lenom=DF.locale["unknow"]
				end
				latooltip=latooltip.."   "..lenom.." ["..tostring(spellId).."]\n"
				
				DF.spellsList[num].texte=finalname
				DF.spellsList[num].valeur=spellId
				DF.spellsList[num].ltype=1
				DF.spellsList[num].popup=true
				DF.spellsList[num].check=nil
				DF.spellsList[num].tooltip=latooltip

				DF.spellsListCheck[num].texte=finalname
				DF.spellsListCheck[num].valeur=spellId
				DF.spellsListCheck[num].ltype=1
				DF.spellsListCheck[num].popup=true
				DF.spellsListCheck[num].check=true
				
				if DF_cdsList[spellId]~=nil then
					DF.spellsListCheck[num].check=false
				end
				
				DF.spellsListCheck[num].tooltip=latooltip				
				
				num=num+1

			end

	   end
	   
	end
	
	-- fusion liste special
	local nb=getn(DF.spellsListspecial)
	
	for i = 1,nb do
	
		if DF.spellsListspecial[i].ltype==1 then
			
			lenom,lerang = GetSpellInfo(DF.spellsListspecial[i].texte)
			finalname="(C) "
			latooltip="|cFFFFFF00Sorts prédéfinies|cFFFFFFFF\n"
			temp=DF:explode ( ";", DF.spellsListspecial[i].valeur )
			nbIds = getn(temp)
			for li = 1,nbIds do
				lid=tonumber(temp[li])
				tnom=GetSpellInfo(lid)
				if tnom==nil then
					tnom=DF.locale["unknow"]
				end
				latooltip=latooltip.."   "..tnom.." ["..tostring(lid).."]\n"
			end
			
		else

			lenom,lerang = GetItemInfo(DF.spellsListspecial[i].texte)
			finalname="(P) "
			latooltip="|cFFFFFF00Proc d'objets|cFFFFFFFF\n"
			temp=DF:explode ( ";", DF.spellsListspecial[i].valeur )
			nbIds = getn(temp)
			for li = 1,nbIds do
				lid=tonumber(temp[li])
				tnom=GetSpellInfo(lid)
				if tnom==nil then
					tnom=DF.locale["unknow"]
				end
				latooltip=latooltip.."   "..tnom.." ["..tostring(lid).."]\n"
			end			
		end

		if (not lenom or lenom==nil) then
			lenom="Unknow ID["..DF.spellsListspecial[i].texte.."]"
			lerang=""
		end

		if string.len(lenom)>32 then
			lenom=string.sub(lenom, 1 ,32).."..."
		end

		if DF.spellsListspecial[i].alttexte then
			
			finalname=finalname..DF.spellsListspecial[i].alttexte
			
		else
	
			finalname=finalname..lenom
			
		end
		
		DF.spellsList[num]={}
		DF.spellsList[num].texte=finalname
		DF.spellsList[num].valeur=DF.spellsListspecial[i].valeur
		DF.spellsList[num].ltype=2
		DF.spellsList[num].popup=false
		DF.spellsList[num].check=nil
		DF.spellsList[num].tooltip=latooltip
		
		num=num+1		
		
	end	

	-- trier la liste
	local mini=0
	local valeur=""
	local save ={}
	local nb=getn(DF.spellsList)
	
	for i = 1,nb do
		mini=i
		valeur=DF.spellsList[mini].texte
		for j = i,nb do
			if i~=j and DF.spellsList[j].texte<valeur then
				mini=j
				valeur=DF.spellsList[mini].texte
			end
		end
		
		save = DF.spellsList[i]
		DF.spellsList[i]=DF.spellsList[mini]
		DF.spellsList[mini]=save
		
	end

	-- trier la liste
	local mini=0
	local valeur=""
	local save ={}
	local nb=getn(DF.spellsListCheck)
	
	for i = 1,nb do
		mini=i
		valeur=DF.spellsListCheck[mini].texte
		for j = i,nb do
			if i~=j and DF.spellsListCheck[j].texte<valeur then
				mini=j
				valeur=DF.spellsListCheck[mini].texte
			end
		end
		
		save = DF.spellsListCheck[i]
		DF.spellsListCheck[i]=DF.spellsListCheck[mini]
		DF.spellsListCheck[mini]=save
		
	end
		
end

function DF:spellsList_activeCDs()
	newPt=DF.myArgs
	lid=tonumber(DF.spellsListCheck[newPt].valeur)
	if DF.spellsListCheck[newPt].check then
		DF_cdsList[lid]=nil
	else
		DF_cdsList[lid]=true
	end

end